package dns

// Code generated by http://github.com/gojuno/minimock (3.0.6). DO NOT EDIT.

//go:generate minimock -i github.com/rekby/lets-proxy2/internal/dns.ResolverInterface -o ./resolver_interface_mock_test.go

import (
	"context"
	"net"
	"sync"
	mm_atomic "sync/atomic"
	mm_time "time"

	"github.com/gojuno/minimock/v3"
)

// ResolverInterfaceMock implements ResolverInterface
type ResolverInterfaceMock struct {
	t minimock.Tester

	funcLookupIPAddr          func(ctx context.Context, host string) (ia1 []net.IPAddr, err error)
	inspectFuncLookupIPAddr   func(ctx context.Context, host string)
	afterLookupIPAddrCounter  uint64
	beforeLookupIPAddrCounter uint64
	LookupIPAddrMock          mResolverInterfaceMockLookupIPAddr
}

// NewResolverInterfaceMock returns a mock for ResolverInterface
func NewResolverInterfaceMock(t minimock.Tester) *ResolverInterfaceMock {
	m := &ResolverInterfaceMock{t: t}
	if controller, ok := t.(minimock.MockController); ok {
		controller.RegisterMocker(m)
	}

	m.LookupIPAddrMock = mResolverInterfaceMockLookupIPAddr{mock: m}
	m.LookupIPAddrMock.callArgs = []*ResolverInterfaceMockLookupIPAddrParams{}

	return m
}

type mResolverInterfaceMockLookupIPAddr struct {
	mock               *ResolverInterfaceMock
	defaultExpectation *ResolverInterfaceMockLookupIPAddrExpectation
	expectations       []*ResolverInterfaceMockLookupIPAddrExpectation

	callArgs []*ResolverInterfaceMockLookupIPAddrParams
	mutex    sync.RWMutex
}

// ResolverInterfaceMockLookupIPAddrExpectation specifies expectation struct of the ResolverInterface.LookupIPAddr
type ResolverInterfaceMockLookupIPAddrExpectation struct {
	mock    *ResolverInterfaceMock
	params  *ResolverInterfaceMockLookupIPAddrParams
	results *ResolverInterfaceMockLookupIPAddrResults
	Counter uint64
}

// ResolverInterfaceMockLookupIPAddrParams contains parameters of the ResolverInterface.LookupIPAddr
type ResolverInterfaceMockLookupIPAddrParams struct {
	ctx  context.Context
	host string
}

// ResolverInterfaceMockLookupIPAddrResults contains results of the ResolverInterface.LookupIPAddr
type ResolverInterfaceMockLookupIPAddrResults struct {
	ia1 []net.IPAddr
	err error
}

// Expect sets up expected params for ResolverInterface.LookupIPAddr
func (mmLookupIPAddr *mResolverInterfaceMockLookupIPAddr) Expect(ctx context.Context, host string) *mResolverInterfaceMockLookupIPAddr {
	if mmLookupIPAddr.mock.funcLookupIPAddr != nil {
		mmLookupIPAddr.mock.t.Fatalf("ResolverInterfaceMock.LookupIPAddr mock is already set by Set")
	}

	if mmLookupIPAddr.defaultExpectation == nil {
		mmLookupIPAddr.defaultExpectation = &ResolverInterfaceMockLookupIPAddrExpectation{}
	}

	mmLookupIPAddr.defaultExpectation.params = &ResolverInterfaceMockLookupIPAddrParams{ctx, host}
	for _, e := range mmLookupIPAddr.expectations {
		if minimock.Equal(e.params, mmLookupIPAddr.defaultExpectation.params) {
			mmLookupIPAddr.mock.t.Fatalf("Expectation set by When has same params: %#v", *mmLookupIPAddr.defaultExpectation.params)
		}
	}

	return mmLookupIPAddr
}

// Inspect accepts an inspector function that has same arguments as the ResolverInterface.LookupIPAddr
func (mmLookupIPAddr *mResolverInterfaceMockLookupIPAddr) Inspect(f func(ctx context.Context, host string)) *mResolverInterfaceMockLookupIPAddr {
	if mmLookupIPAddr.mock.inspectFuncLookupIPAddr != nil {
		mmLookupIPAddr.mock.t.Fatalf("Inspect function is already set for ResolverInterfaceMock.LookupIPAddr")
	}

	mmLookupIPAddr.mock.inspectFuncLookupIPAddr = f

	return mmLookupIPAddr
}

// Return sets up results that will be returned by ResolverInterface.LookupIPAddr
func (mmLookupIPAddr *mResolverInterfaceMockLookupIPAddr) Return(ia1 []net.IPAddr, err error) *ResolverInterfaceMock {
	if mmLookupIPAddr.mock.funcLookupIPAddr != nil {
		mmLookupIPAddr.mock.t.Fatalf("ResolverInterfaceMock.LookupIPAddr mock is already set by Set")
	}

	if mmLookupIPAddr.defaultExpectation == nil {
		mmLookupIPAddr.defaultExpectation = &ResolverInterfaceMockLookupIPAddrExpectation{mock: mmLookupIPAddr.mock}
	}
	mmLookupIPAddr.defaultExpectation.results = &ResolverInterfaceMockLookupIPAddrResults{ia1, err}
	return mmLookupIPAddr.mock
}

//Set uses given function f to mock the ResolverInterface.LookupIPAddr method
func (mmLookupIPAddr *mResolverInterfaceMockLookupIPAddr) Set(f func(ctx context.Context, host string) (ia1 []net.IPAddr, err error)) *ResolverInterfaceMock {
	if mmLookupIPAddr.defaultExpectation != nil {
		mmLookupIPAddr.mock.t.Fatalf("Default expectation is already set for the ResolverInterface.LookupIPAddr method")
	}

	if len(mmLookupIPAddr.expectations) > 0 {
		mmLookupIPAddr.mock.t.Fatalf("Some expectations are already set for the ResolverInterface.LookupIPAddr method")
	}

	mmLookupIPAddr.mock.funcLookupIPAddr = f
	return mmLookupIPAddr.mock
}

// When sets expectation for the ResolverInterface.LookupIPAddr which will trigger the result defined by the following
// Then helper
func (mmLookupIPAddr *mResolverInterfaceMockLookupIPAddr) When(ctx context.Context, host string) *ResolverInterfaceMockLookupIPAddrExpectation {
	if mmLookupIPAddr.mock.funcLookupIPAddr != nil {
		mmLookupIPAddr.mock.t.Fatalf("ResolverInterfaceMock.LookupIPAddr mock is already set by Set")
	}

	expectation := &ResolverInterfaceMockLookupIPAddrExpectation{
		mock:   mmLookupIPAddr.mock,
		params: &ResolverInterfaceMockLookupIPAddrParams{ctx, host},
	}
	mmLookupIPAddr.expectations = append(mmLookupIPAddr.expectations, expectation)
	return expectation
}

// Then sets up ResolverInterface.LookupIPAddr return parameters for the expectation previously defined by the When method
func (e *ResolverInterfaceMockLookupIPAddrExpectation) Then(ia1 []net.IPAddr, err error) *ResolverInterfaceMock {
	e.results = &ResolverInterfaceMockLookupIPAddrResults{ia1, err}
	return e.mock
}

// LookupIPAddr implements ResolverInterface
func (mmLookupIPAddr *ResolverInterfaceMock) LookupIPAddr(ctx context.Context, host string) (ia1 []net.IPAddr, err error) {
	mm_atomic.AddUint64(&mmLookupIPAddr.beforeLookupIPAddrCounter, 1)
	defer mm_atomic.AddUint64(&mmLookupIPAddr.afterLookupIPAddrCounter, 1)

	if mmLookupIPAddr.inspectFuncLookupIPAddr != nil {
		mmLookupIPAddr.inspectFuncLookupIPAddr(ctx, host)
	}

	mm_params := &ResolverInterfaceMockLookupIPAddrParams{ctx, host}

	// Record call args
	mmLookupIPAddr.LookupIPAddrMock.mutex.Lock()
	mmLookupIPAddr.LookupIPAddrMock.callArgs = append(mmLookupIPAddr.LookupIPAddrMock.callArgs, mm_params)
	mmLookupIPAddr.LookupIPAddrMock.mutex.Unlock()

	for _, e := range mmLookupIPAddr.LookupIPAddrMock.expectations {
		if minimock.Equal(e.params, mm_params) {
			mm_atomic.AddUint64(&e.Counter, 1)
			return e.results.ia1, e.results.err
		}
	}

	if mmLookupIPAddr.LookupIPAddrMock.defaultExpectation != nil {
		mm_atomic.AddUint64(&mmLookupIPAddr.LookupIPAddrMock.defaultExpectation.Counter, 1)
		mm_want := mmLookupIPAddr.LookupIPAddrMock.defaultExpectation.params
		mm_got := ResolverInterfaceMockLookupIPAddrParams{ctx, host}
		if mm_want != nil && !minimock.Equal(*mm_want, mm_got) {
			mmLookupIPAddr.t.Errorf("ResolverInterfaceMock.LookupIPAddr got unexpected parameters, want: %#v, got: %#v%s\n", *mm_want, mm_got, minimock.Diff(*mm_want, mm_got))
		}

		mm_results := mmLookupIPAddr.LookupIPAddrMock.defaultExpectation.results
		if mm_results == nil {
			mmLookupIPAddr.t.Fatal("No results are set for the ResolverInterfaceMock.LookupIPAddr")
		}
		return (*mm_results).ia1, (*mm_results).err
	}
	if mmLookupIPAddr.funcLookupIPAddr != nil {
		return mmLookupIPAddr.funcLookupIPAddr(ctx, host)
	}
	mmLookupIPAddr.t.Fatalf("Unexpected call to ResolverInterfaceMock.LookupIPAddr. %v %v", ctx, host)
	return
}

// LookupIPAddrAfterCounter returns a count of finished ResolverInterfaceMock.LookupIPAddr invocations
func (mmLookupIPAddr *ResolverInterfaceMock) LookupIPAddrAfterCounter() uint64 {
	return mm_atomic.LoadUint64(&mmLookupIPAddr.afterLookupIPAddrCounter)
}

// LookupIPAddrBeforeCounter returns a count of ResolverInterfaceMock.LookupIPAddr invocations
func (mmLookupIPAddr *ResolverInterfaceMock) LookupIPAddrBeforeCounter() uint64 {
	return mm_atomic.LoadUint64(&mmLookupIPAddr.beforeLookupIPAddrCounter)
}

// Calls returns a list of arguments used in each call to ResolverInterfaceMock.LookupIPAddr.
// The list is in the same order as the calls were made (i.e. recent calls have a higher index)
func (mmLookupIPAddr *mResolverInterfaceMockLookupIPAddr) Calls() []*ResolverInterfaceMockLookupIPAddrParams {
	mmLookupIPAddr.mutex.RLock()

	argCopy := make([]*ResolverInterfaceMockLookupIPAddrParams, len(mmLookupIPAddr.callArgs))
	copy(argCopy, mmLookupIPAddr.callArgs)

	mmLookupIPAddr.mutex.RUnlock()

	return argCopy
}

// MinimockLookupIPAddrDone returns true if the count of the LookupIPAddr invocations corresponds
// the number of defined expectations
func (m *ResolverInterfaceMock) MinimockLookupIPAddrDone() bool {
	for _, e := range m.LookupIPAddrMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			return false
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.LookupIPAddrMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterLookupIPAddrCounter) < 1 {
		return false
	}
	// if func was set then invocations count should be greater than zero
	if m.funcLookupIPAddr != nil && mm_atomic.LoadUint64(&m.afterLookupIPAddrCounter) < 1 {
		return false
	}
	return true
}

// MinimockLookupIPAddrInspect logs each unmet expectation
func (m *ResolverInterfaceMock) MinimockLookupIPAddrInspect() {
	for _, e := range m.LookupIPAddrMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			m.t.Errorf("Expected call to ResolverInterfaceMock.LookupIPAddr with params: %#v", *e.params)
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.LookupIPAddrMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterLookupIPAddrCounter) < 1 {
		if m.LookupIPAddrMock.defaultExpectation.params == nil {
			m.t.Error("Expected call to ResolverInterfaceMock.LookupIPAddr")
		} else {
			m.t.Errorf("Expected call to ResolverInterfaceMock.LookupIPAddr with params: %#v", *m.LookupIPAddrMock.defaultExpectation.params)
		}
	}
	// if func was set then invocations count should be greater than zero
	if m.funcLookupIPAddr != nil && mm_atomic.LoadUint64(&m.afterLookupIPAddrCounter) < 1 {
		m.t.Error("Expected call to ResolverInterfaceMock.LookupIPAddr")
	}
}

// MinimockFinish checks that all mocked methods have been called the expected number of times
func (m *ResolverInterfaceMock) MinimockFinish() {
	if !m.minimockDone() {
		m.MinimockLookupIPAddrInspect()
		m.t.FailNow()
	}
}

// MinimockWait waits for all mocked methods to be called the expected number of times
func (m *ResolverInterfaceMock) MinimockWait(timeout mm_time.Duration) {
	timeoutCh := mm_time.After(timeout)
	for {
		if m.minimockDone() {
			return
		}
		select {
		case <-timeoutCh:
			m.MinimockFinish()
			return
		case <-mm_time.After(10 * mm_time.Millisecond):
		}
	}
}

func (m *ResolverInterfaceMock) minimockDone() bool {
	done := true
	return done &&
		m.MinimockLookupIPAddrDone()
}
